% GLIDE.M - vygeneruje radu tonu s rostouci frekvenci
%           po dosazeni Nyq. frekvence se tony zacnou prekladat   
%-----------------------------------------------------------

clear all;

Fs = 20000; % zvol vzorkovaci frekvenci

t=0:1/Fs:0.2; %casove vzorky v ramci 0.2 s

f = 100; q = 2^(1/12);
t1 = 0.2*Fs;
tend = 1;


for k = 0:60 
   f1 = f * q^k
   ton = sin(2*pi*f1*t(1:t1));
  %sound (ton);
  % tony ulozime do pole
   tstart=tend;
   tend=tstart+t1-1;
   mel(tstart:tend)=ton;
end

% prehrajeme cele pole
sound (mel,Fs,16)

% zobrazime spektrum melodie
[B,f,t] = spectrogram (mel, hamming(256), 0, 256, Fs);
imagesc(t,f,20*log10(abs(B))), axis xy, colormap (winter);

wavwrite(mel,Fs,16,'glide16khz.wav')

