% FILTRDEM.M  Jednoducha ukazka filtrovani signalu

echo on

% Nejprve vytvorime signal slozeny z nekolika sinusovek
% sinusovky o frekvencich 50, 100, 200 Hz

f1 = 50; f2 = 100; f3 = 200;
fi1 = 0; fi2 = 0; fi3 = 0;
Fs = 1000;  %vzorkovaci frekvence
t=0:1/Fs:1;   % casova osa
x = sin(2*pi*f1*t + fi1) + sin(2*pi*f2*t + fi2) + sin(2*pi*f3*t + fi3);

subplot (2,2,1)  % zobrazime signal
plot (t(1:100),x(1:100))
axis ([0, 0.1, -4, 4])
subplot (2,2,3) % zobrazime jeho spektrogram
[B,f,t1] = specgram (x, 256, Fs, hamming(256));
imagesc(t1,f,20*log10(abs(B))), axis xy, colormap (jet);

pause % stiskni klavesu

% chceme odfiltrovat jednu ze slozek signalu - napr f2
% navrhneme IIR filtr napr. Butterworth
figure (2)
[b,a] = butter(10,[80 120]/(Fs/2), 'stop');
freqz (b,a,256, Fs) % vykresli frekvenci charakteristiku filtru

pause % stiskni klavesu

figure (1)
subplot (2,2,2)
y = filter (b,a, x);
plot (t(1:100),y(1:100))
axis ([0, 0.1, -4, 4])

subplot (2,2,4)
[B,f,t1] = specgram (y, 256, Fs, hamming(256));
imagesc(t1,f,20*log10(abs(B))), axis xy, colormap (jet);
