%RECAECHO.M - analyza signalu slozeneho z reci a sinusovky
% -------------------------------------------------------------


echo on

%nacti signal 
[rec,Fs] = wavread('dobryden.wav');


%odstran stejnosmernou slozku
rec = rec - mean(rec);

%pridej echo
zpoz = 500;    %zpozdeni
utlum = 0.5     %utlum echa
len = length(rec);
echo off;
for k = 1:len-zpoz,
   rec(k+zpoz)=rec(k+zpoz)+utlum*rec(k);
end
echo on
sound (rec)




%vykresli
subplot(2,2,1)
len = length (rec);
rmin = min(rec); rmax=max(rec);
frames = fix(len /160);
t=(0:len-1)/Fs;

plot(t, rec)
axis([0,len/Fs, rmin, rmax]);
xlabel('cas - s')
ylabel('Amplituda')

pause


%spocitej FFT nejprve pro cely signal

delkafft = 8192
frec = fft(rec,delkafft);

subplot (2,2,2)
%vygeneruj frekvencni osu
pol = delkafft/2;
frosa = (0:pol-1)/pol*Fs/2;
plot (frosa, abs(frec(1:pol)))
axis ([0, 4000, 0, 10]);
title ('Spectrum signalu ')
xlabel ('frekvence - Hz')
ylabel ('amplituda')

pause  


%spocitej FFT vzdy pro dalsich 160 vzorku
for frame = 0:frames-1
   st = frame * 160 + 1;
   en = st + 160;
   rec1 = rec(st:en);
   delkafft = 4096;
   frec = fft(rec1,delkafft);

   figure (1), subplot(2,2,2)
   %vygeneruj frekvencni osu
   pol = delkafft/2;
   frosa = (0:pol-1)/pol*Fs/2;
   plot (frosa, abs(frec(1:pol)))
   axis ([0, 4000, 0, 10]);
   title ('Spectrum signalu ')
   xlabel ('frekvence - Hz')
   ylabel ('amplituda')
   pause (0.00001);
   echo off
end
echo on

pause

subplot (2,2,3)

[B,f,t] = specgram (rec, 128, Fs, hamming(128));
imagesc(t,f,20*log10(abs(B))), axis xy, colormap (jet);

pause

subplot (2,2,4)
colormap (jet);
meshz (20*log10(abs(B)));
echo off

