% RECASINF.M - odfiltrovani tonu od signalu reci
%-------------------------------------------------------------
echo on

%nacti signal 
[rec,Fs] = wavread('dobryden.wav');

%odstran stejnosmernou slozku

orig = rec;
rec = rec - mean(rec);

%nyni vygeneruj sinusovku s danou frekvenci
Fsin = 2000;
t=0:1/Fs:1;
t = t(1:length(rec));
ton = 0.01*sin(2*pi*Fsin*t);
rec = rec + 10*ton';
sound (rec)

%vykresli
subplot(2,2,1)
len = length (rec);
rmin = min(rec); rmax=max(rec);
frames = fix(len /160);
t=(0:len-1)/Fs;

plot(t, rec)
axis([0,len/Fs, rmin, rmax]);
xlabel('cas - s')
ylabel('Amplituda')

pause

subplot (2,2,2)

[B,f,t1] = specgram (rec, 128, Fs, hamming(128));
imagesc(t1,f,20*log10(abs(B))), axis xy, colormap (jet);
pause

subplot (2,2,3)

% navrh filtru pro odfiltrovani tonu
subplot (2,2,3)
[tfd,tfn,tfa]=dfdiir('bw','bs','impulse',[3 30], Fs ,[0.95 1.05]*Fsin,[0.98 1.02]*Fsin)
b=tfd(1,:);
a=tfd(2,:);

% signal po odfiltrovani tonu
subplot (2,2,3)
y = filter (b,a,rec);
plot(t, y)
axis([0,len/Fs, rmin, rmax]);
xlabel('cas - s')
ylabel('Amplituda')
sound (y) % prehraj filtrovany signal
pause 
subplot (2,2,4)
[B,f,t1] = specgram (y, 128, Fs, hamming(128));
imagesc(t1,f,20*log10(abs(B))), axis xy, colormap (jet);

sound (orig)   % prehraj jeste jednou original