% TIMFRQ.M - demonstruje dualitu casoveho a frekvencniho popisu 

%nejprve vytvorime signal o delce 1024 vzorku z nekolika sinusovek

Fs = 1024; %vzorkovaci frekvence 1024 Hz

t=(0:1023)/Fs;  %vygeneruje casove vzorky

%signal slozime ze tri cosinusovek 50, 330 a 100 Hz 
%s fazovym posuvem 0, 0.2 a -0.5 a s amplitudami 1, 2 a 3.
s = 1*cos(2*pi*50*t + 0) + 2*cos(2*pi*330*t +0.2) + 3*cos(2*pi*100*t -0.5);

%zobrazime prvnich 100 vzorku
subplot (2,2,1)
plot (t(1:100), s(1:100))
title ('Originalni signal')


%zobrazime amplitudovou frekvencni charakteristiku
F=fft(s);
f = 0:Fs/2-1;
amp = abs(F)/(Fs/2);  %amplitudu delime poctem vzorku, abychom dostali spravnou hodnotu
subplot (2,2,2)
plot (f,amp(1:length(f)));
title ('Amplitudova frekv. ch.')

%zobrazime fazovou frekvencni charakteristiku
%vypocet je explicitni, ne pres funkci angle, ktera nepracuje dobre u cisel blizkych nule
for k = 1:Fs
  if (abs(real(F(k)))<0.01 | abs(imag(F(k)))<0.01)
      ang(k) = 0;
   else 
      ang(k) = atan2(imag(F(k)),real(F(k)));
   end
   echo off
end
echo on
subplot (2,2,3)
plot (f,ang(1:length(f)));
title ('Fazova frekv. ch.')


%provedeme zpetnou Fourierovou transformaci
q = ifft(F);
subplot (2,2,4)
plot (t(1:100), q(1:100))
title ('Po inverzni transformaci')