% FILTR.M - vygeneruje 4 tony o frekvenci f1, f2, f3, f4 
% a odfiltruje frekvenci f2
% -------------------------------------------------------

echo off;
close all;
clear variables;
clear global;

% vzorkovaci frekvence
Fs = 8000;

% nastaveni zvukove osy
saxis ([-40 40]);  

%vygeneruj casovou osu 
t=0:1/Fs:0.5;
poct=0.5*Fs;

%zadane frekvence
f1=400;
f2=600;
f3=800;
f4=1000;

%Vygeneruje do pole zvuk posloupnost tonu o frekvencich fi
tend=1;
ton = 20*sin(2*pi*f1*t);
tstart=tend;
tend=tstart+poct;
zvuk(tstart:tend)=ton;
ton = 20*sin(2*pi*f2*t);
tstart=tend;
tend=tstart+poct;
zvuk(tstart:tend)=ton;
ton = 20*sin(2*pi*f3*t);
tstart=tend;
tend=tstart+poct;
zvuk(tstart:tend)=ton;
ton = 20*sin(2*pi*f4*t);
tstart=tend;
tend=tstart+poct;
zvuk(tstart:tend)=ton;


%vykresli prubeh
subplot(2,2,1);
plot(zvuk);
title('Nefiltrovan signl');

% Zobrazime jeho spektrogram
subplot (2,2,2)
[B,f,t1] = specgram (zvuk, 256, Fs, hamming(256));
imagesc(t1,f,20*log10(abs(B))), axis xy, colormap (jet);
title('Jeho spektogram');

%Prehraje pole zvuk
sound(zvuk);

echo on
pause % stiskni klavesu
echo off

% navrhneme filtr IIR - Butterworth na zatlumeni f2
fs1=550;
fs2=650;
fp1=500;
fp2=700;

Fs1=fs1/(Fs/2);
Fs2=fs2/(Fs/2);
Fp1=fp1/(Fs/2);
Fp2=fp2/(Fs/2);

Wp=[Fp1, Fp2];
Ws=[Fs1, Fs2];

[N,Wn]=buttord(Wp, Ws, 0.5, 30);
[b, a]=butter(N,Wn, 'stop');
figure (2);
freqz(b,a,256, Fs);
title('Navren Butterworthv filtr na frekvenci 600 Hz');
zvukf=filter(b, a, zvuk);
echo on
pause % stiskni klavesu
echo off;

%zobrazi vyfiltorvany zvuk
figure (1);
subplot(2,2,3);
plot(zvukf);
title('Odfiltrovan sloka 600 Hz');

% Zobrazime jeho spektrogram
subplot (2,2,4);
[B,f,t1] = specgram (zvukf, 256, Fs, hamming(256));
imagesc(t1,f,20*log10(abs(B))), axis xy, colormap (jet);
title('Jeho spektrogram');
sound(zvukf);
